package net.pricefx.common.apibuilder.chart;

import net.pricefx.common.api.chart.AuxLineColor;
import net.pricefx.common.apibuilder.BacklinkBuilder;
import net.pricefx.common.apibuilder.ObjectIdentity;

public class TrendLine<S extends ObjectIdentity> extends BacklinkBuilder<S> {

	public TrendLine(final S backLink, final String instanceId, final String classId) {
		super(instanceId, classId, backLink);
	}

	public TrendLine<S> setLabel(final String label) {
		addInvocation("setLabel",label);
		return this;
	}

	/**
	 * Assume a linear (y=a+bx) or exponential (y=a*e^bx) relationship between dependent variable y and independent variables x. 
	 * @param regressionType 'linear' or 'exponential'
	 * @return
	 */
	public TrendLine<S> setRegressionType(final String regressionType) {
		addInvocation("setRegressionType",regressionType);
		return this;
	}

	public TrendLine<S> setShowInLegend(final Boolean showInLegend) {
		addInvocation("setShowInLegend",showInLegend);
		return this;
	}
	
	public TrendLine<S> setHideDataLabels(final Boolean hideDataLabels) {
		addInvocation("setHideDataLabels",hideDataLabels);
		return this;
	}

	public TrendLine<S> setColor(final AuxLineColor color) {
		addInvocation("setColor",color);
		return this;
	}

}