package net.pricefx.domain;

import java.text.SimpleDateFormat;
import java.util.*;


import org.joda.time.DateTime;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;

public abstract class PersistedObject {

    public static final String FIELD_ID = "id";
    public static final String FIELD_LASTUPDATEDATE = "lastUpdateDate";
	public static final String FIELD_CREATEDATE = "createDate";
	public static final String FIELD_ISDELETED = "isDeleted";

	public PersistedObject() {
		Date now = new Date();
//		Long currentUser = UserContext.getCurrentUser();
		this.createDate = now;
//		this.createdBy = currentUser;
		this.lastUpdateDate = now;
//		this.lastUpdateBy = currentUser;
	}

	private Long id;
	
	private Long version;
		
    private Date createDate;
    
    private Long createdBy;
    	
    private Date lastUpdateDate;
    
    private Long lastUpdateBy;
	
    private Date deleteDate;
    
    private Long deletedBy;
    
    private boolean isDeleted;
    
    private String typedId;
    
	@JsonProperty(value="createdBy")
    public Long getCreatedBy() {
		return createdBy;
	}

	@JsonIgnore
	public void setCreatedBy(Long createdBy) {
		this.createdBy = createdBy;
	}

	@JsonProperty(value="lastUpdateBy")
	public Long getLastUpdateBy() {
		return lastUpdateBy;
	}

	@JsonIgnore
	public void setLastUpdateBy(Long lastUpdateBy) {
		this.lastUpdateBy = lastUpdateBy;
	}

	@JsonIgnore
	public Date getDeleteDate() {
		return deleteDate;
	}

	@JsonIgnore
	public void setDeleteDate(Date deleteDate) {
		this.deleteDate = deleteDate;
	}

	@JsonIgnore
	public Long getDeletedBy() {
		return deletedBy;
	}

	@JsonIgnore
	public void setDeletedBy(Long deletedBy) {
		this.deletedBy = deletedBy;
	}

	@JsonIgnore
	public boolean isDeleted() {
		return isDeleted;
	}

	@JsonIgnore
	public void setDeleted(boolean isDeleted) {
		this.isDeleted = isDeleted;
	}
	
	public Long getVersion() {
		return version;
	}

	public void setVersion(Long version) {
		this.version = version;
	}
	
	public void bumpVersion() {
		this.version = Long.valueOf(this.version.longValue() + 1);
	}	

	@JsonIgnore
	public Date getCreateDate() {
		return createDate;
	}

	@JsonProperty(value="createDate")
/*
	public String createDate() {
		if(createDate == null) return null;
		return (new SimpleDateFormat(S.getDateTimePattern())).format(createDate);	//just to externalize it
	}
*/

//	@JsonProperty(value="createDate")
	public void setCreateDateShouldBeIgnored(Date createDate) {
		// just to satisfy deserialization
	}

	// just to satisfy jackson 
	public void setCreateDateTime(DateTime datetime) {}
	
	@JsonIgnore
	public void setCreateDate(Date createDate) {
		this.createDate = createDate;
	}

	@JsonIgnore
	public Date getLastUpdateDate() {
		return lastUpdateDate;
	}

	@JsonProperty(value = FIELD_LASTUPDATEDATE)
/*
	public String lastUpdateDate() {
		if(lastUpdateDate == null) return null;
		return (new SimpleDateFormat(S.getDateTimePattern())).format(lastUpdateDate);	//just to externalize it
	}
*/

	// just to satisfy jackson 
	public void setLastUpdateDateTime(DateTime dateTime) {}
	
	@JsonIgnore
	public void setLastUpdateDate(Date lastUpdateDate) {
		this.lastUpdateDate = lastUpdateDate;
	}

	@JsonIgnore
	public Long getId() {
		return id;
	}

	@JsonIgnore
	public void setId(Long id) {
		this.id = id;
	}

/*
	public String getTypedId(){
		return (getId() == null)? typedId : (getId() + "." + (getTypeCode() == null ? null : getTypeCode().getCodeString()));
	}
*/

	public void setTypedId( String typedId ){
		this.typedId = typedId; 
	}
	
	@JsonIgnore
	public String[] getSignificantFields() {
		return new String[] { FIELD_ID };
	}
	
	@JsonIgnore
	public LinkedHashMap<String,Object> getBulkloadMap() {
		LinkedHashMap<String,Object> map = new LinkedHashMap<String,Object>();
   		
		//we do not add any fields here as the bulk load command auto-fill these values
		
		return map;
	}

}
