package net.pricefx.logic.core.model;

import net.pricefx.common.api.FormulaNature;
import net.pricefx.common.api.IFormulaNature;
import net.pricefx.restapiclient.model.BaseMap;


public class PricingFormula extends AbstractFormula {

    public PricingFormula() {
    }

    @Override
    public PricingFormulaElement createElement() {
        return new PricingFormulaElement();
    }

    @Override
    public PricingFormulaElement createElement(BaseMap element) {
        return fromObject(element, PricingFormulaElement.class);
    }

    @Override
    public final boolean isPricingLogic() {
        return true;
    }

    @Override
    public final boolean isWorkflowLogic() {
        return false;
    }

    public final boolean isGroovyLibrary() {
        return FormulaNature.LIBRARY.equals(getFormulaNatureObject());
    }

    @Override
    public IFormulaNature getFormulaNatureObject() {
        return FormulaNature.getViaDBValue(getFormulaNature());
    }
}

